VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "07_02TextureCoordinates"
   ClientHeight    =   5640
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6795
   Height          =   6015
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   5640
   ScaleWidth      =   6795
   Top             =   1110
   Width           =   6915
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   5655
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6735
      _Version        =   131072
      _ExtentX        =   11880
      _ExtentY        =   9975
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Initialize()
   
    Dim root As SoGroup
    Set root = New SoGroup
    'Choose a texture
    Dim brick As SoTexture2
    Set brick = New SoTexture2
   
    Call root.addChild(brick)
    Call brick.filename.setValue(V3Space1.getRegistryDataPath() + "\examples\data\brick_1.rgb")


    'This is the preferred code for Inventor 2.1

    'Using the new SoVertexProperty node is more efficient
    'Dim myVertexProperty As SoVertexProperty
    Set myVertexProperty = New SoVertexProperty

    'Define the square's spatial coordinates
    Call myVertexProperty.vertex.set1Value(0, -3, -3, 0)
    Call myVertexProperty.vertex.set1Value(1, 3, -3, 0)
    Call myVertexProperty.vertex.set1Value(2, 3, 3, 0)
    Call myVertexProperty.vertex.set1Value(3, -3, 3, 0)

    'Define the square's normal
    'Call myVertexProperty.Normal.set1Value(0, 0, 0, 1)

    'Define the square's texture coordinates
    Call myVertexProperty.texCoord.set1Value(0, 0, 0)
    Call myVertexProperty.texCoord.set1Value(1, 1, 0)
    Call myVertexProperty.texCoord.set1Value(2, 1, 1)
    Call myVertexProperty.texCoord.set1Value(3, 0, 1)

    'SoTextureCoordinateBinding node is now obsolete--in Inventor 2.1,
    'texture coordinates will always be generated if none are
    'provided.
    'SoTextureCoordinateBinding *tBind =
    '        new SoTextureCoordinateBinding;
    ' root->addChild(tBind);
    ' tBind->value = SoTextureCoordinateBinding::PER_VERTEX;
    'Define normal binding
    Call myVertexProperty.normalBinding.setValue(2) 'SoNormalBinding::OVERALL;

    'Define a FaceSet
    Dim myFaceSet As SoFaceSet
    Set myFaceSet = New SoFaceSet
    Call root.addChild(myFaceSet)
    Call myFaceSet.numVertices.set1Value(0, 4)

    Call myFaceSet.vertexProperty.setValue(myVertexProperty)

    Call V3Space1.setSceneRoot(root)
    Call V3Space1.viewAll
    
    Set root = Nothing
    Set brick = Nothing
    Set myVertexProperty = Nothing
    Set myFaceSet = Nothing
    
End Sub

