VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "13_7 Rotor"
   ClientHeight    =   4845
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6555
   Height          =   5220
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4845
   ScaleWidth      =   6555
   Top             =   1110
   Width           =   6675
   Begin VB.Label Label1 
      Caption         =   "This example read in a windmill tower and vanes.  It uses a SoRotor node to rotate the vanes."
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6375
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   3735
      Left            =   120
      TabIndex        =   0
      Top             =   1080
      Width           =   6375
      _Version        =   131072
      _ExtentX        =   11245
      _ExtentY        =   6588
      _StockProps     =   0
      decorationOn    =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Initialize()

    Dim root As SoSeparator
    Set root = New SoSeparator
    
    Dim windmillTower As Object
    
    Set windmillTower = readFile(V3Space1.getRegistryDataPath() + "\examples\data\windmillTower.iv")

    Call root.addChild(windmillTower)

    'Add a rotor node to spin the vanes
    Dim myRotor As SoRotor
    Set myRotor = New SoRotor
    Dim vec3f As SbVec3f
    Set vec3f = New SbVec3f
    Call vec3f.setValue(0, 0, 1)
    Call myRotor.rotation.setValueAxis(vec3f, (M_PI / 32#)) 'z axis
    Call myRotor.speed.setValue(0.1)
    Call root.addChild(myRotor)

    'Read in the data for the windmill vanes
    Dim windmillVanes As Object
    Set windmillVanes = readFile(V3Space1.getRegistryDataPath() + "\examples\data\windmillVanes.iv")
   
    Call root.addChild(windmillVanes)
    Call V3Space1.setSceneRoot(root)
    Call V3Space1.viewAll
End Sub

Public Function readFile(fileName As String) As Object

    Dim myInput As SoInput
    Set myInput = New SoInput
    
    Set readFile = myInput.readAllUrl(fileName, V3Space1.GetIDispatch())
End Function
